|  | Home · All Classes · Modules

# QDeclarativeNetworkAccessManagerFactory Class Reference
[QtDeclarative module]

The QDeclarativeNetworkAccessManagerFactory class creates QNetworkAccessManager instances for a QML engine. More...

### Methods

- __init__ (self)
- __init__ (self, QDeclarativeNetworkAccessManagerFactory)
- QNetworkAccessManager create (self, QObject parent)

## Detailed Description

The QDeclarativeNetworkAccessManagerFactory class creates QNetworkAccessManager instances for a QML engine.

A QML engine uses QNetworkAccessManager for all network access. By implementing a factory, it is possible to provide the QML engine with custom QNetworkAccessManager instances with specialized caching, proxy and cookies support.

To implement a factory, subclass QDeclarativeNetworkAccessManagerFactory and implement the virtual create() method, then assign it to the relevant QML engine using QDeclarativeEngine.setNetworkAccessManagerFactory().

Note the QML engine may create QNetworkAccessManager instances from multiple threads. Because of this, the implementation of the create() method must be reentrant. In addition, the developer should be careful if the signals of the object to be returned from create() are connected to the slots of an object that may be created in a different thread:

- The QML engine internally handles all requests, and cleans up any QNetworkReply objects it creates. Receiving the QNetworkAccessManager.finished() signal in another thread may not provide the receiver with a valid reply object if it has already been deleted.
- Authentication details provided to QNetworkAccessManager.authenticationRequired() must be provided immediately, so this signal cannot be connected as a Qt.QueuedConnection (or as the default Qt.AutoConnection from another thread).

For more information about signals and threads, see Threads and QObjects and Signals and Slots Across Threads.

## Method Documentation

### QDeclarativeNetworkAccessManagerFactory.__init__ (self)

### QDeclarativeNetworkAccessManagerFactory.__init__ (self, QDeclarativeNetworkAccessManagerFactory)

### QNetworkAccessManager QDeclarativeNetworkAccessManagerFactory.create (self, QObject parent)

This method is abstract and should be reimplemented in any sub-class.

The parent argument, if not None, causes self to be owned by Qt instead of PyQt.

Creates and returns a network access manager with the specified parent. This method must return a new QNetworkAccessManager instance each time it is called.

Note: this method may be called by multiple threads, so ensure the implementation of this method is reentrant.